///////////////////////////////////////////////////////////////////
//
//   PACKAGE :   edu.gmu.csiss.wcsclient.goes
//   CLASS   :   getTIFF
//   FUNCTION:   read image data from tiff file  via WCS  service  
//   AUTHOR  :   hfan
//   TIME    :   04/12/2007
////////////////////////////////////////////////////////////////////
package edu.gmu.csiss.wcsclient.goes;

import java.awt.image.DataBuffer;
import java.awt.image.Raster;
import java.awt.image.SampleModel;
import java.io.BufferedOutputStream;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.text.DecimalFormat;

import javax.media.jai.JAI;
import javax.media.jai.PlanarImage;

public class getTIFF {
	int imageW;
	int imageH;
	int responseType;
    String type;
    float dataArray[]=null;
	String urlstring;
	String downloaddir="c:/downloads/";
	String downloadfname="goes.tiff";

	public getTIFF(String urlstr){
		urlstring = urlstr;
		responseType = httpDownload();
		if(responseType>0)
	          imageDatafromTIFF();
	  }
	
    public getTIFF(String serverpath,String service,String version,String coverage){//crs omitted
    	setSuburl( serverpath,service,version,coverage);
    	responseType = httpDownload();
		if(responseType>0)
			  imageDatafromTIFF();
	  }

    public getTIFF(String serverpath,String service,String version,String coverage,String format){//boundingbox and crs omitted
    	setSuburl( serverpath,service,version,coverage);
    	if(format.length()>0) 	//empty string
 		  urlstring = urlstring +"&format="+format;
		responseType = httpDownload();
		if(responseType>0)
          imageDatafromTIFF();
	  }
	
    public getTIFF(String serverpath,String service,String version,String coverage,String format, String boundingbox){//crs omitted
    	setSuburl( serverpath,service,version,coverage);
    	if(format.length()>0) 	//not empty string
 		  urlstring = urlstring +"&format="+format;
    	if(boundingbox.length() > 0) //not empty string
		  urlstring =  urlstring +"&boundingbox="+boundingbox;
		responseType = httpDownload();
		if(responseType>0)
		  imageDatafromTIFF();
	  }
    
	
	
	public getTIFF(String serverpath,String service,String version,String coverage,String format, String boundingbox,String GridBaseCRS){
    	setSuburl( serverpath,service,version,coverage);
    	if(format.length()>0) 	//not empty string
 		  urlstring = urlstring +"&format="+format;
    	if(boundingbox.length() > 0) //not empty string
		  urlstring =  urlstring +"&boundingbox="+boundingbox;
    	if(GridBaseCRS.length() > 0) //not empty string
  		  urlstring =  urlstring +"&GridBaseCRS="+GridBaseCRS;
		responseType = httpDownload();
		if(responseType>0)
			  imageDatafromTIFF();
	  }

	public getTIFF(String serverpath,String service,String version,String coverage,String format, String boundingbox,String GridBaseCRS, String RangeSubset){
    	setSuburl( serverpath,service,version,coverage);
    	if(format.length()>0) 	//not empty string
 		  urlstring = urlstring +"&format="+format;
    	if(boundingbox.length() > 0) //not empty string
		  urlstring =  urlstring +"&boundingbox="+boundingbox;
    	if(GridBaseCRS.length() > 0) //not empty string
  		  urlstring =  urlstring +"&GridBaseCRS="+GridBaseCRS;
    	if(RangeSubset.length() > 0) //not empty string
    		  urlstring =  urlstring +"&RangeSubset="+RangeSubset;
		
		responseType = httpDownload();
		if(responseType>0)
			  imageDatafromTIFF();
	  }

	public getTIFF(String serverpath,String service,String version,String coverage,String format, String boundingbox,String GridBaseCRS, String RangeSubset, String GridOffsets ){
    	setSuburl( serverpath,service,version,coverage);
    	if(format.length()>0) 	//not empty string
 		  urlstring = urlstring +"&format="+format;
    	if(boundingbox.length() > 0) //not empty string
		  urlstring =  urlstring +"&boundingbox="+boundingbox;
    	if(GridBaseCRS.length() > 0) //not empty string
  		  urlstring =  urlstring +"&GridBaseCRS="+GridBaseCRS;
    	if(RangeSubset.length() > 0) //not empty string
    		  urlstring =  urlstring +"&RangeSubset="+RangeSubset;
    	if(GridOffsets.length() > 0) //not empty string
  		  urlstring =  urlstring +"&GridOffsets="+GridOffsets;
		
		responseType = httpDownload();
		if(responseType>0)
			  imageDatafromTIFF();
	  }
	
	
	public getTIFF(String serverpath,String service,String version,String coverage,String format, String boundingbox,String GridBaseCRS, String RangeSubset, String GridOffsets, String GridOrigin ){
		setSuburl( serverpath,service,version,coverage);
    	if(format.length()>0) 	//not empty string
 		  urlstring = urlstring +"&format="+format;
    	if(boundingbox.length() > 0) //not empty string
		  urlstring =  urlstring +"&boundingbox="+boundingbox;
    	if(GridBaseCRS.length() > 0) //not empty string
  		  urlstring =  urlstring +"&GridBaseCRS="+GridBaseCRS;
    	if(RangeSubset.length() > 0) //not empty string
    		  urlstring =  urlstring +"&RangeSubset="+RangeSubset;
    	if(GridOffsets.length() > 0) //not empty string
  		  urlstring =  urlstring +"&GridOffsets="+GridOffsets;
    	if(GridOrigin.length() > 0) //not empty string
    		  urlstring =  urlstring +"&GridOrigin="+GridOrigin;
		
		responseType = httpDownload();
		if(responseType>0)
			  imageDatafromTIFF();
	  }
	
	public getTIFF(String serverpath,String service,String version,String coverage,String format, String boundingbox,String GridBaseCRS, String RangeSubset, String GridOffsets, String GridOrigin, boolean store){
		setSuburl( serverpath,service,version,coverage);
    	if(format.length()>0) 	//not empty string
 		  urlstring = urlstring +"&format="+format;
    	if(boundingbox.length() > 0) //not empty string
		  urlstring =  urlstring +"&boundingbox="+boundingbox;
    	if(GridBaseCRS.length() > 0) //not empty string
  		  urlstring =  urlstring +"&GridBaseCRS="+GridBaseCRS;
    	if(RangeSubset.length() > 0) //not empty string
    		  urlstring =  urlstring +"&RangeSubset="+RangeSubset;
    	if(GridOffsets.length() > 0) //not empty string
  		  urlstring =  urlstring +"&GridOffsets="+GridOffsets;
    	if(GridOrigin.length() > 0) //not empty string
    		  urlstring =  urlstring +"&GridOrigin="+GridOrigin;
    	urlstring =  urlstring +"&store="+store;
		
		responseType = httpDownload();
		if(responseType>0)
			  imageDatafromTIFF();
	  }
	
	private void setSuburl(String serverpath,String service,String version,String coverage){
		if(serverpath == null && serverpath.length() == 0) 	//empty string
			serverpath = "data.laits.gmu.edu/cgi-bin/wcs110";
		if(version == null && version.length() == 0) 	//empty string
			version= "1.1.0";
		urlstring = "http://"+serverpath+"?service="+service+"&version="+version+"&request=getCoverage&identifier="+coverage;
	  }

	private int httpDownload() {
	 int responseType = 0;
   	 try{
 	  		// Create one directory
 	  		boolean success = (new File(downloaddir)).mkdir();
// 	  		if (success) {
// 	  			System.out.println("Directory: " + downloaddir + " created");
// 	  		}		
	    	
    		 
    		URL  url  =  new URL(urlstring); 
			HttpURLConnection httpConnection = (HttpURLConnection) url.openConnection();
			httpConnection.connect();
			InputStream in = httpConnection.getInputStream();
			File dirFile = new File(downloaddir);
			dirFile.mkdirs();
			String localFile = dirFile + File.separator + downloadfname;
			BufferedOutputStream out = new BufferedOutputStream(new FileOutputStream(localFile));
			byte[] buffer = new byte[1024];
	
			int count = in.read(buffer);
			if(count == 26)
				responseType = 1;
			else if(count == 27)
				responseType =0;
			
			while (count > 0) {
			out.write(buffer, 0, count);
			count = in.read(buffer);
		}
			httpConnection.disconnect();
			in.close();
			out.close();
 			
    	 }
    	  catch (Exception ioe) {
         	 System.out.println("IOException:"+ioe);
        }
       return responseType;
     }


  
   private void imageDatafromTIFF( ) {
        String filename = downloaddir + downloadfname; 
        PlanarImage image1 = JAI.create("fileload",filename);
        Raster image1Raster = image1.getData();
        imageW = image1Raster.getWidth();
        imageH = image1Raster.getHeight();
        int numPixels = imageW * imageH;
        SampleModel sm = image1.getSampleModel();
        switch(sm.getDataType()) {
	      	 case DataBuffer.TYPE_BYTE: type="byte"; break;
	      	 case DataBuffer.TYPE_SHORT: type="short"; break;
	      	 case DataBuffer.TYPE_USHORT: type="ushort"; break;
	      	 case DataBuffer.TYPE_INT: type="int"; break;
	      	 case DataBuffer.TYPE_FLOAT: type="float"; break;
      	     case DataBuffer.TYPE_DOUBLE: type="double"; break;
	      	 case DataBuffer.TYPE_UNDEFINED:type="undefined"; break;
	    }

        //  Now extract the red band data from image1 ...
        dataArray = new float[numPixels];
        int entry = 0;
        for (int h = 0; h < imageH; h++)
          for (int w = 0; w < imageW; w++)
           dataArray[entry++] = image1Raster.getSample(w,h,0);
    }	           

    public void data2GRIDFile(String filename)
	{
    	DecimalFormat df;
	    PrintWriter txtOut;
        try{
  	        txtOut = new PrintWriter(new BufferedWriter(new FileWriter(filename)));
  	        txtOut.print("ncols         "+imageW+"\n");
  	        txtOut.print("nrows         "+imageH+"\n");
  	        txtOut.print("xllcorner     0\n");
  	        txtOut.print("yllcorner     0\n");
  	        txtOut.print("cellsize      1\n");
  	        txtOut.print("NODATA_value  -9999\n");

  	        if(dataArray[0]>255.0)
  	            df = new DecimalFormat("00000.0");
  	        else
  	        	df = new DecimalFormat("000.0");
  		    
  	        for(int h=0;h<imageH;h++)  {
              for(int w=0;w<imageW;w++)  {
  	      		txtOut.print(df.format(dataArray[h*imageW+w]));
  	      		txtOut.print(" ");
  	          }    	
        	txtOut.print("\n");
          }
          txtOut.close();
        }catch(IOException ioe){
      	   System.out.println("IOException:"+ioe);
        }

	 }
	  
    public float[] getDataFromImage() {   return dataArray;   }
    public int getImageW()     {   return imageW;    }
	public int getImageH()    {   return imageH;   }  
	public int getResponseType()    {   return responseType;   }  
	public String getImageType() {   return type;   }  

}

